
/* Board specific functions for those embedded 8xx boards that do
 * not have boot monitor support for board information.
 */
#include <linux/types.h>
#include <linux/config.h>
#ifdef CONFIG_8xx
#include <asm/mpc8xx.h>
#endif
#ifdef CONFIG_8260
#include <asm/mpc8260.h>
#endif
#ifdef CONFIG_SNOM1
#include <asm/port.h>
#endif

/* IIC functions.
 * These are just the basic master read/write operations so we can
 * examine serial EEPROM.
 */
extern void	iic_read(uint devaddr, u_char *buf, uint offset, uint count);
extern u_char	aschex_to_byte(u_char *cp);

/* Supply a default Ethernet address for those eval boards that don't
 * ship with one.  This is an address from the MBX board I have, so
 * it is unlikely you will find it on your network.
 */
static	ushort	def_enet_addr[] = { 0x0800, 0x3e26, 0x1559 };

#ifdef CONFIG_SNOM1

void print_snom_logo()
{
  puts("\n\n\n\n\n");
  puts("\n                                        oo");
  puts("\n                sss   nn  nnnn      oo   oo     mmm  mmm");
  puts("\n               ss      nnn    nn   oo     oo  mm   mm   mm");
  puts("\n                ss     nn     nn  oo      oo  mm   mm   mm");
  puts("\n                 ss    nn     nn  oo      oo  mm   mm   mm");
  puts("\n                ss     nn     nn  oo     oo   mm   mm   mm");
  puts("\n              sss      nn     nn   oo   oo    mm   mm   mm");
  puts("\n                                     oo");
  puts("\n\n                                                              technology AG\n\n\n\n");
}


int test_sdram1(void)
{
  *((volatile unsigned long *) 4) = 0x00000000;
 
  if(*((volatile unsigned long *) 4) & 0x00000001) goto upper;
  if(*((volatile unsigned long *) 4) & 0x00000002) goto upper;
  if(*((volatile unsigned long *) 4) & 0x00000004) goto upper;
  if(*((volatile unsigned long *) 4) & 0x00000008) goto upper;
  if(*((volatile unsigned long *) 4) & 0x00000010) goto upper;
  if(*((volatile unsigned long *) 4) & 0x00000020) goto upper;
  if(*((volatile unsigned long *) 4) & 0x00000040) goto upper;
  if(*((volatile unsigned long *) 4) & 0x00000080) goto upper;
  if(*((volatile unsigned long *) 4) & 0x00000100) goto upper;
  if(*((volatile unsigned long *) 4) & 0x00000200) goto upper;
  if(*((volatile unsigned long *) 4) & 0x00000400) goto upper;
  if(*((volatile unsigned long *) 4) & 0x00000800) goto upper;
  if(*((volatile unsigned long *) 4) & 0x00001000) goto upper;
  if(*((volatile unsigned long *) 4) & 0x00002000) goto upper;
  if(*((volatile unsigned long *) 4) & 0x00004000) goto upper;
  if(*((volatile unsigned long *) 4) & 0x00008000) goto upper;

  if(*((volatile unsigned long *) 4) & 0x00010000) goto upper;
  if(*((volatile unsigned long *) 4) & 0x00020000) goto upper;
  if(*((volatile unsigned long *) 4) & 0x00040000) goto upper;
  if(*((volatile unsigned long *) 4) & 0x00080000) goto upper;
  if(*((volatile unsigned long *) 4) & 0x00100000) goto upper;
  if(*((volatile unsigned long *) 4) & 0x00200000) goto upper;
  if(*((volatile unsigned long *) 4) & 0x00400000) goto upper;
  if(*((volatile unsigned long *) 4) & 0x00800000) goto upper;
  if(*((volatile unsigned long *) 4) & 0x01000000) goto upper;
  if(*((volatile unsigned long *) 4) & 0x02000000) goto upper;
  if(*((volatile unsigned long *) 4) & 0x04000000) goto upper;
  if(*((volatile unsigned long *) 4) & 0x08000000) goto upper;
  if(*((volatile unsigned long *) 4) & 0x10000000) goto upper;
  if(*((volatile unsigned long *) 4) & 0x20000000) goto upper;
  if(*((volatile unsigned long *) 4) & 0x40000000) goto upper;
  if(*((volatile unsigned long *) 4) & 0x80000000) goto upper;

  *((volatile unsigned long *) 4) = 0xffffffff;

  if((*((volatile unsigned long *) 4) & 0x00000001) != 0x00000001) goto upper;
  if((*((volatile unsigned long *) 4) & 0x00000002) != 0x00000002) goto upper;
  if((*((volatile unsigned long *) 4) & 0x00000004) != 0x00000004) goto upper;
  if((*((volatile unsigned long *) 4) & 0x00000008) != 0x00000008) goto upper;
  if((*((volatile unsigned long *) 4) & 0x00000010) != 0x00000010) goto upper;
  if((*((volatile unsigned long *) 4) & 0x00000020) != 0x00000020) goto upper;
  if((*((volatile unsigned long *) 4) & 0x00000040) != 0x00000040) goto upper;
  if((*((volatile unsigned long *) 4) & 0x00000080) != 0x00000080) goto upper;
  if((*((volatile unsigned long *) 4) & 0x00000100) != 0x00000100) goto upper;
  if((*((volatile unsigned long *) 4) & 0x00000200) != 0x00000200) goto upper;
  if((*((volatile unsigned long *) 4) & 0x00000400) != 0x00000400) goto upper;
  if((*((volatile unsigned long *) 4) & 0x00000800) != 0x00000800) goto upper;
  if((*((volatile unsigned long *) 4) & 0x00001000) != 0x00001000) goto upper;
  if((*((volatile unsigned long *) 4) & 0x00002000) != 0x00002000) goto upper;
  if((*((volatile unsigned long *) 4) & 0x00004000) != 0x00004000) goto upper;
  if((*((volatile unsigned long *) 4) & 0x00008000) != 0x00008000) goto upper;

  if((*((volatile unsigned long *) 4) & 0x00010000) != 0x00010000) goto upper;
  if((*((volatile unsigned long *) 4) & 0x00020000) != 0x00020000) goto upper;
  if((*((volatile unsigned long *) 4) & 0x00040000) != 0x00040000) goto upper;
  if((*((volatile unsigned long *) 4) & 0x00080000) != 0x00080000) goto upper;
  if((*((volatile unsigned long *) 4) & 0x00100000) != 0x00100000) goto upper;
  if((*((volatile unsigned long *) 4) & 0x00200000) != 0x00200000) goto upper;
  if((*((volatile unsigned long *) 4) & 0x00400000) != 0x00400000) goto upper;
  if((*((volatile unsigned long *) 4) & 0x00800000) != 0x00800000) goto upper;
  if((*((volatile unsigned long *) 4) & 0x01000000) != 0x01000000) goto upper;
  if((*((volatile unsigned long *) 4) & 0x02000000) != 0x02000000) goto upper;
  if((*((volatile unsigned long *) 4) & 0x04000000) != 0x04000000) goto upper;
  if((*((volatile unsigned long *) 4) & 0x08000000) != 0x08000000) goto upper;
  if((*((volatile unsigned long *) 4) & 0x10000000) != 0x10000000) goto upper;
  if((*((volatile unsigned long *) 4) & 0x20000000) != 0x20000000) goto upper;
  if((*((volatile unsigned long *) 4) & 0x40000000) != 0x40000000) goto upper;
  if((*((volatile unsigned long *) 4) & 0x80000000) != 0x80000000) goto upper;

 upper:
  *((volatile unsigned long *)0x800004) = 0x00000000;

  if(*((volatile unsigned long *)0x800004) & 0x00000001) goto fail1;
  if(*((volatile unsigned long *)0x800004) & 0x00000002) goto fail1;
  if(*((volatile unsigned long *)0x800004) & 0x00000004) goto fail1;
  if(*((volatile unsigned long *)0x800004) & 0x00000008) goto fail1;
  if(*((volatile unsigned long *)0x800004) & 0x00000010) goto fail1;
  if(*((volatile unsigned long *)0x800004) & 0x00000020) goto fail1;
  if(*((volatile unsigned long *)0x800004) & 0x00000040) goto fail1;
  if(*((volatile unsigned long *)0x800004) & 0x00000080) goto fail1;
  if(*((volatile unsigned long *)0x800004) & 0x00000100) goto fail1;
  if(*((volatile unsigned long *)0x800004) & 0x00000200) goto fail1;
  if(*((volatile unsigned long *)0x800004) & 0x00000400) goto fail1;
  if(*((volatile unsigned long *)0x800004) & 0x00000800) goto fail1;
  if(*((volatile unsigned long *)0x800004) & 0x00001000) goto fail1;
  if(*((volatile unsigned long *)0x800004) & 0x00002000) goto fail1;
  if(*((volatile unsigned long *)0x800004) & 0x00004000) goto fail1;
  if(*((volatile unsigned long *)0x800004) & 0x00008000) goto fail1;

  if(*((volatile unsigned long *)0x800004) & 0x00010000) goto fail1;
  if(*((volatile unsigned long *)0x800004) & 0x00020000) goto fail1;
  if(*((volatile unsigned long *)0x800004) & 0x00040000) goto fail1;
  if(*((volatile unsigned long *)0x800004) & 0x00080000) goto fail1;
  if(*((volatile unsigned long *)0x800004) & 0x00100000) goto fail1;
  if(*((volatile unsigned long *)0x800004) & 0x00200000) goto fail1;
  if(*((volatile unsigned long *)0x800004) & 0x00400000) goto fail1;
  if(*((volatile unsigned long *)0x800004) & 0x00800000) goto fail1;
  if(*((volatile unsigned long *)0x800004) & 0x01000000) goto fail1;
  if(*((volatile unsigned long *)0x800004) & 0x02000000) goto fail1;
  if(*((volatile unsigned long *)0x800004) & 0x04000000) goto fail1;
  if(*((volatile unsigned long *)0x800004) & 0x08000000) goto fail1;
  if(*((volatile unsigned long *)0x800004) & 0x10000000) goto fail1;
  if(*((volatile unsigned long *)0x800004) & 0x20000000) goto fail1;
  if(*((volatile unsigned long *)0x800004) & 0x40000000) goto fail1;
  if(*((volatile unsigned long *)0x800004) & 0x80000000) goto fail1;

  *((volatile unsigned long *)0x800004) = 0xffffffff;

  if((*((volatile unsigned long *)0x800004) & 0x00000001) != 0x00000001) goto fail1;
  if((*((volatile unsigned long *)0x800004) & 0x00000002) != 0x00000002) goto fail1;
  if((*((volatile unsigned long *)0x800004) & 0x00000004) != 0x00000004) goto fail1;
  if((*((volatile unsigned long *)0x800004) & 0x00000008) != 0x00000008) goto fail1;
  if((*((volatile unsigned long *)0x800004) & 0x00000010) != 0x00000010) goto fail1;
  if((*((volatile unsigned long *)0x800004) & 0x00000020) != 0x00000020) goto fail1;
  if((*((volatile unsigned long *)0x800004) & 0x00000040) != 0x00000040) goto fail1;
  if((*((volatile unsigned long *)0x800004) & 0x00000080) != 0x00000080) goto fail1;
  if((*((volatile unsigned long *)0x800004) & 0x00000100) != 0x00000100) goto fail1;
  if((*((volatile unsigned long *)0x800004) & 0x00000200) != 0x00000200) goto fail1;
  if((*((volatile unsigned long *)0x800004) & 0x00000400) != 0x00000400) goto fail1;
  if((*((volatile unsigned long *)0x800004) & 0x00000800) != 0x00000800) goto fail1;
  if((*((volatile unsigned long *)0x800004) & 0x00001000) != 0x00001000) goto fail1;
  if((*((volatile unsigned long *)0x800004) & 0x00002000) != 0x00002000) goto fail1;
  if((*((volatile unsigned long *)0x800004) & 0x00004000) != 0x00004000) goto fail1;
  if((*((volatile unsigned long *)0x800004) & 0x00008000) != 0x00008000) goto fail1;

  if((*((volatile unsigned long *)0x800004) & 0x00010000) != 0x00010000) goto fail1;
  if((*((volatile unsigned long *)0x800004) & 0x00020000) != 0x00020000) goto fail1;
  if((*((volatile unsigned long *)0x800004) & 0x00040000) != 0x00040000) goto fail1;
  if((*((volatile unsigned long *)0x800004) & 0x00080000) != 0x00080000) goto fail1;
  if((*((volatile unsigned long *)0x800004) & 0x00100000) != 0x00100000) goto fail1;
  if((*((volatile unsigned long *)0x800004) & 0x00200000) != 0x00200000) goto fail1;
  if((*((volatile unsigned long *)0x800004) & 0x00400000) != 0x00400000) goto fail1;
  if((*((volatile unsigned long *)0x800004) & 0x00800000) != 0x00800000) goto fail1;
  if((*((volatile unsigned long *)0x800004) & 0x01000000) != 0x01000000) goto fail1;
  if((*((volatile unsigned long *)0x800004) & 0x02000000) != 0x02000000) goto fail1;
  if((*((volatile unsigned long *)0x800004) & 0x04000000) != 0x04000000) goto fail1;
  if((*((volatile unsigned long *)0x800004) & 0x08000000) != 0x08000000) goto fail1;
  if((*((volatile unsigned long *)0x800004) & 0x10000000) != 0x10000000) goto fail1;
  if((*((volatile unsigned long *)0x800004) & 0x20000000) != 0x20000000) goto fail1;
  if((*((volatile unsigned long *)0x800004) & 0x40000000) != 0x40000000) goto fail1;
  if((*((volatile unsigned long *)0x800004) & 0x80000000) != 0x80000000) goto fail1;

 success1:
  return 0;
 fail1:
  return -1;
}

// return 0 if everything was ok
int test_sdram7() {
  register int i;
  register volatile unsigned long *p;
  register volatile unsigned char *b;
  puts("testing SDRAM\n");

  // primitive test:
  p = (volatile unsigned long *)0x4;
  *p = 0;
  if (*p != 0) { puts("cannot write 0\n"); return 1; }
  *p = 0xffffffff;
  if (*p != 0xffffffff) { puts("cannot write 0xffffffff\n"); return 1; }
  
  // test1: test if all data lines are ok
  puts("Testing data lines: ");
  for(i = 0; i < 32; i++) {
    *p = (1L << i);
    if (*p == (1L << i))
      puts(".");
    else {
      puts("X");
      return 1;
    }
  }
  puts(" ");
  for(i = 0; i < 32; i++) {
    *p = ~(1L << i);
    if (*p == ~(1L << i))
      puts(".");
    else {
      puts("X");
      return 1;
    }
  }

  // test byte access:
  puts("\nTesting byte access: ");
  b = (volatile unsigned char *)0x4;
  b[0] = 0x11;
  b[1] = 0x22;
  b[2] = 0x33;
  b[3] = 0x44;
  if (b[0] != 0x11) { puts("byte 0 failed\n"); return 1; }
  if (b[1] != 0x22) { puts("byte 1 failed\n"); return 1; }
  if (b[2] != 0x33) { puts("byte 2 failed\n"); return 1; }
  if (b[3] != 0x44) { puts("byte 3 failed\n"); return 1; }

  // test2: test if all address lines are ok
  puts("\nTesting address lines: ");
  for(i = 2; i < 20; i++) {
    p = (volatile unsigned long *)(1L << i);
    *p = (unsigned long)p;
  }

  for(i = 2; i < 20; i++) {
    p = (volatile unsigned long *)(1L << i);
    if (*p == (unsigned long)p)
      puts(".");
    else {
      puts("X");
      return 1;
    }
  }
  return 0;
}

int test_sdram6(void)
{
  register volatile unsigned long *p =
    (volatile unsigned long *) 0;

  while(p < (unsigned long *) 0x010000) {
    *p = (unsigned long) p;
    p++;
  }

  p = 0;
  while(p < (unsigned long *) 0x010000) {
    if(*p != (unsigned long) p)
      goto fail6;
    p++;
  }
 success6:
  return 0;
 fail6:
  return -1;
}

int test_sdram2(void)
{
  register volatile unsigned long *p =
    (volatile unsigned long *) 0;

  while(p < (unsigned long *) 0x010000) {
    *p = 0;
    p++;
  }

  p = 0;
  while(p < (unsigned long *) 0x010000) {
    if(*p != 0)
      goto fail2;
    p++;
  }
 success2:
  return 0;
 fail2:
  return -1;
}

void print_reset_regs(void)
{
  puts("RSR = "); puthex(_get_RSR()); puts("\n");
  puts("MSR = "); puthex(_get_MSR()); puts("\n");
  /*
  puts("SSR0 = "); puthex(_get_SSR0()); puts("\n");
  puts("SSR1 = "); puthex(_get_SRR1()); puts("\n");
  */
  udelay(100000);
}

int test_sdram3a(void)
{
  int i;
  register volatile unsigned long *p =
    (volatile unsigned long *) 0x800000;

  puts("Copying print_reset_regs call to 0x100 ...");

  for(i=0;i<4;i++) {
    ((unsigned long *) (0x100))[i] = ((unsigned long *) 0xfe040010)[i];
  }

  puts("Writing 0x800000 to 0x810000 with 0xffffffff ..."); 

  while(p < (unsigned long *) 0x810000) {
    *p = 0xffffffff;
    p++;
  }

  puts("ok\n"); 
  udelay(10000);
}

int test_sdram3b(void)
{
  int fail = 0;
  register volatile unsigned long *p =
    (volatile unsigned long *) 0x800000;
  unsigned long value;

  puts("Reading 0x800000 to 0x810000 ... "); 

  while(p < (unsigned long *) 0x0810000) {
    value = *p;
    if(value != 0xffffffff) {
      fail = 1;
      puts("failed at "); puthex(p); puts(" val = "); puthex(value);
      puts("\n");
    }
    p++;
  }

  return fail;
}

int test_sdram4(void)
{
  register volatile unsigned long *p =
    (volatile unsigned long *) 0;

  while(p < (unsigned long *) 0x010000) {
    *p = 0x55555555;
    p++;
  }

  p = 0;
  while(p < (unsigned long *) 0x010000) {
    if(*p != 0x55555555)
      goto fail4;
    p++;
  }
 success4:
  return 0;
 fail4:
  return -1;
}

int test_sdram5(void)
{
  register volatile unsigned long *p =
    (volatile unsigned long *) 0;

  while(p < (unsigned long *) 0x010000) {
    *p = 0xaaaaaaaa;
    p++;
  }

  p = 0;
  while(p < (unsigned long *) 0x010000) {
    if(*p != 0xaaaaaaaa)
      goto fail5;
    p++;
  }
 success5:
  return 0;
 fail5:
  return -1;
}

void
copy_snom1_data_seg(void)
{
  volatile unsigned char *p1 = (volatile unsigned char *) 0xfe050000;
  volatile unsigned char *p2 = (volatile unsigned char *) 0x300000;
  int i;

  for(i=0;i<0x10000;i++)
  {
    *p2 = *p1;
    p1++; p2++;
  }
}

/* This function determines the parameters that the board has.

   They are deduced from the serial number of the SNOM board. */

void
snom1_cfg(bd_t *bd_ram)
{
  int i, serial_num;

	/* Get the Ethernet station address from the Flash ROM.
	*/

	for(i=0;i<6;i++) {
	  bd_ram->bi_enetaddr[i] = ((volatile unsigned char *) 0xfe030000)[i];
	}

	serial_num = 	(bd_ram->bi_enetaddr[3] << 16) |
			(bd_ram->bi_enetaddr[4] <<  8) |
			(bd_ram->bi_enetaddr[5]);

	/* The rest of this should come from the environment as well.
	*/

	/* Shut audio off ! */
	set_port(PORT_C, (1<<2) | (1<<3), 0);
	set_port_dir(PORT_C, OUTPUT_PINS, (1<<2) | (1<<3));
	  
	bd_ram->bi_memstart = 0;
	bd_ram->bi_memsize = 0x01000000; /* 16 Mb */
	//bd_ram->bi_baudrate = 9600;
	bd_ram->bi_baudrate = 57600;
	
	// get the multiplication factor: we do this by reading out the plprcr (see config_snomxxx.h in bootloader).
	// bd_ram->bi_mf = serial_num < 30 ? 10 : 12;
	bd_ram->bi_mf = ((((immap_t *)IMAP_ADDR)->im_clkrst.car_plprcr >> 20) & 0xfff) + 1;
	bd_ram->bi_exclk = serial_num < 30 ? 5000000 : 4096000;

	if(serial_num < 1000)
		bd_ram->bi_flash_type = FLASH_2MB;
	else if(serial_num < 2000)
		bd_ram->bi_flash_type = FLASH_2x2MB;
	else 
		bd_ram->bi_flash_type = FLASH_4MB;

}

#define GET_SERIAL_NUM \
	register int serial_num; \
	register unsigned char *puc = (unsigned char *) 0xfe030000; \
	puc += 3; \
	serial_num = *puc; \
	serial_num <<= 8; \
	puc++; \
	serial_num |= *puc; \
	serial_num <<= 8; \
	puc++; \
	serial_num |= *puc;

#define BR0_VAL 0xfe000801  	/* BA=0xfe000000, AT=000, PS=10 (16 bit),
                                   PARE=0 (disable), WP=0 (RW),
                                   MS=00 (GPCM), V=1 (Valid) */
 
#define OR0_2MB_VAL 0xffe00d34  /* AM=0xffe00000 (2MB), all types access,
                                   CS early negate, 6 w.s., timing relax */
 
#define OR0_4MB_VAL 0xffc00d34  /* AM=0xffc00000 (4MB), all types access,
                                   CS early negate, 6 w.s., timing relax */
 
#define BR1_2x2MB_VAL 0xfe200801  /* BA=0xfe200000, AT=000, PS=10 (16 bit),
                                   PARE=0 (disable), WP=0 (RW),
                                   MS=00 (GPCM), V=1 (Valid) */
 
#define OR1_2x2MB_VAL 0xffe00d34  /* AM=0xffe00000 (2MB), all types access,
                                   CS early negate, 6 w.s., timing relax */  
	
char *snom_get_cmd_line(void)
{
	GET_SERIAL_NUM
	return (char *) (serial_num < 1000 ? 0xfe1f0000 : 0xfe3f0000);
}

int snom_get_or0_val(void)
{
	GET_SERIAL_NUM
	return serial_num < 2000 ? OR0_2MB_VAL : OR0_4MB_VAL;
}

int snom_get_br0_val(void)
{
	return BR0_VAL;
}

int snom_get_or1_val(void)
{
	GET_SERIAL_NUM
	if((serial_num < 1000) || (serial_num >= 2000)) {
		return 0;
        } else {
		return OR1_2x2MB_VAL;
	}
}

int snom_get_br1_val(void)
{
	GET_SERIAL_NUM
	if((serial_num < 1000) || (serial_num >= 2000)) {
		return 0;
        } else {
		return BR1_2x2MB_VAL;
	}
}

#define PLPRCR_VAL1	0x00904000   	/* 0-29 have 5 Mhz external */
#define PLPRCR_VAL2	0x00b04000 	/* >= 30 have 4.096 Mhz external */

int snom_get_plprcr_val(void)
{
	GET_SERIAL_NUM
	return serial_num >= 30 ? PLPRCR_VAL2 : PLPRCR_VAL1;
}

#endif

#ifdef CONFIG_FADS

void
copy_fads_data_seg(void)
{
  volatile unsigned char *p1 = (volatile unsigned char *) 0xfe050000;
  volatile unsigned char *p2 = (volatile unsigned char *) 0x300000;
  int i;

  for(i=0;i<0x10000;i++)
  {
    *p2 = *p1;
    p1++; p2++;
  }
}

void
fads_cfg(bd_t *bd_ram)
{
	u_char	*cp;
	int	i;
	uint	*ptr, val;
	int *j;
	volatile unsigned int *bscr1 = (unsigned int *) BCSR1;
	volatile unsigned int *bscr4 = (unsigned int *) BCSR4;

	j = (int *)0x4;

	/* Move the BCSR chip select to kernel space area
	*/
	ptr = (uint *)&(((immap_t *)IMAP_ADDR)->im_memctl.memc_br1);
	val = *ptr & 0x7fff;		/* Keep what ever is already there */
	*ptr = val | (uint) (BCSR_ADDR & 0xffff8000);
	*j = (int) ptr;

	/* Serial ports */
	(*bscr1) &= ~(1<<24); /* enable serial port 1 */

	/* Ethernet Initialisation */

#if CONFIG_FEC_ENET

	(*bscr1) |= (1<<29); /* disable SCC1 ethernet port */

	(*bscr4) |= (1<<25);  /* full duplex */
	(*bscr4) |= (1<<26);  /* 10 Mbps */
	(*bscr4) |= (1<<22);  /* disable 10 Mbps link test */

	(*bscr4) &= ~(1<<27); /* enable fast ethernet port */

	(*bscr4) &= ~(1<<21); /* reset the Level One chip */
	udelay(10);
	(*bscr4) |= (1<<21);

#endif

#ifdef CONFIG_SCC_ENET

	(*bscr4) &= ~(1<<31); /* disable ethernet loopback */
	(*bscr4) &= ~(1<<30); /* enable twisted pair */
	(*bscr4) |= (1<<29);  /* disable quality test port */

	(*bscr1) &= ~(1<<29); /* enable ethernet port */

#endif

	/* The rest of this should come from the environment as well.
	*/
	bd_ram->bi_memstart = 0;

	bd_ram->bi_memsize = 0x00c00000; /* 12 Mb */
	bd_ram->bi_intfreq = 50;
	bd_ram->bi_busfreq = 50;
#ifdef CONFIG_SNOM220
	bd_ram->bi_baudrate = 57600;
#else
	bd_ram->bi_baudrate = 9600;
#endif
/* Get the Ethernet station address from the Flash ROM.
	*/

	bd_ram->bi_enetaddr[0] = 0xfa;
	bd_ram->bi_enetaddr[1] = 0xaf;
	bd_ram->bi_enetaddr[2] = 0x00;
	bd_ram->bi_enetaddr[3] = 0x01;
	bd_ram->bi_enetaddr[4] = 0x02;
	bd_ram->bi_enetaddr[5] = 0x03;
}
#endif
