/***********************************************************************

 This module is used to access the ports of the MPC860/855 and the 
 control and status register of the SNOM1 board. It provides
 an abstraction layer above the different physical layers. 

************************************************************************/

/*** Types */

typedef enum { PORT_A, PORT_B, PORT_C, PORT_SNOM_CSR } t_port;
typedef enum { INPUT_PINS, OUTPUT_PINS } t_port_dir;

/*** Procedures */

extern int  read_port(t_port port);
extern void set_port(t_port port, int set_bit_mask, int clear_bit_mask);
extern void set_port_dir(t_port port, t_port_dir port_dir, int bit_mask);

